#include <opencv2/opencv.hpp>

int main( int argc, char** argv )
{
	// rfIt@Cǂݍ
	cv::VideoCapture	capture( "images/input.mp4" );
	cv::Mat frame, mask, dst, diff;
	cv::VideoWriter 	writer( "images/output.avi",
		cv::VideoWriter::fourcc( 'M', 'J', 'P', 'G' ),
		capture.get( cv::CAP_PROP_FPS ),
		cv::Size( ( int )capture.get( cv::CAP_PROP_FRAME_WIDTH ), ( int )capture.get( cv::CAP_PROP_FRAME_HEIGHT ) ) );

	// EBhE쐬
	cv::namedWindow( "Video Frame" );
	cv::namedWindow( "Mask" );
	cv::namedWindow( "Inpainted" );

	for( ;; ) {
		// rfIt[ǂݍ
		capture >> frame;
		if( frame.empty() ) {
			break;
		}

		// t[2lŃCyCgp}XN𐶐
		cv::cvtColor( frame, mask, cv::COLOR_BGR2GRAY );
		cv::threshold( mask, mask, 90, 255, cv::THRESH_BINARY_INV );
		cv::dilate( mask, mask, cv::Mat(), cv::Point( -1, -1 ), 2 );

		// t[摜ɑ΂ăCyCgKp
		cv::inpaint( frame, mask, dst, 3, cv::INPAINT_TELEA );

		// t[摜ƃCyCgʂ\
		cv::imshow( "Video Frame", frame );
		cv::imshow( "Mask", mask );
		cv::imshow( "Inpainted", dst );
		cv::waitKey( 1000 / capture.get( cv::CAP_PROP_FPS ) );
		writer << dst;
	}

	return 0;
}