#include <opencv2/opencv.hpp>

int main( int argc, char** argv )
{
	// rfIt@Cǂݍ
	cv::VideoCapture	capture( "images/input.mp4" );
	cv::Mat		frame;
	cv::VideoWriter 	writer( "images/output.avi", cv::VideoWriter::fourcc( 'M', 'J', 'P', 'G' ), 
		capture.get( cv::CAP_PROP_FPS ),
		cv::Size( ( int )capture.get( cv::CAP_PROP_FRAME_WIDTH ),
			( int )capture.get( cv::CAP_PROP_FRAME_HEIGHT ) ) );

	// EBhE쐬
	cv::namedWindow( "Video Frame" );

	// rfIt@C\ĕۑ
	for( ;; ) {
		capture >> frame;
		if( frame.empty() ) {
			break;
		}
		cv::imshow( "Video Frame", frame );
		cv::waitKey( 1000 / capture.get( cv::CAP_PROP_FPS ) );
		writer << frame;
	}

	return 0;
}
